#undef	DEBUG


#include <stdio.h>
#include <errno.h>
#include <unistd.h>		/* getopt(), read(), write(), close(), STDIN_FILENO */
#include <stdlib.h>		/* strtol(), malloc() */
#include <sys/types.h>		/* open(), socket(), connect(), ulong */
#include <sys/stat.h>		/* open() */
#include <fcntl.h>		/* open(), O_RDONLY */
#include <string.h>		/* strlen() */
#include <sys/socket.h>		/* socket(), connect() */
#include <netdb.h>		/* gethostbyname() */
#include <netinet/in.h>		/* htons(), struct_sockaddr_in, struct in_addr */
#include <arpa/inet.h>		/* inet_addr() */


#define VERBOSE_CHANNEL	stderr		/* verbose channel */
#define	STD_CHANNEL	stdout		/* output channel */
#define HELP_CHANNEL	stdout	
#define	VERSION_CHANNEL	stdout
#define ERROR_CHANNEL	stderr
#define DEBUG_CHANNEL	stderr

#define	DEFAULT_HOST		"localhost"
#define	DEFAULT_PORT		80
#define	BUFFER_BASE_SIZE	32
#define	ANSWER_BUFFER_SIZE	(16*1024)
#define	RETVAL_OK	0
#define	RETVAL_MALLOC	1
#define	RETVAL_BUG	2
#define	RETVAL_QUERY	3
#define	RETVAL_ERROR	4

#define VERSION_NUMBER		"0.03"
#define DATE_OF_LAST_MOD	"1999-09-09"
#define	MY_EMAIL_ADDRESS	"Steffen Solyga <solyga@absinth.net>"

#define	MIN( A, B )		( (A)<(B) ? (A) : (B) )
#define	NON_ASCII( A )		( (A)==0||(A)>0x7f?1:0 )
#define	IS_PRINTABLE( A )	( (A)>0x1f&&(A)<0x7f?1:0 )

#define	N_( A )			A
/* taken from resolv/herror.c of glibc-2.0.7 */
const char *h_errlist[] = {
        N_("Resolver Error 0 (no error)"),
        N_("Unknown host"),                     /* 1 HOST_NOT_FOUND */
        N_("Host name lookup failure"),         /* 2 TRY_AGAIN */
        N_("Unknown server error"),             /* 3 NO_RECOVERY */
        N_("No address associated with name"),  /* 4 NO_ADDRESS */
};


typedef unsigned char	UCHAR;
